
///////////////////////////////////////////////////////////
// Company         : Micro Digital                       //
// Address         : Office # C7 Raza Plaza              //
//                   DAV College Road                    //
//                   Rawalpindi,                         //
//                   Pakistan.                           //
// Programmed By   : Rashid Mehmood                      //
// Project Name    : PC Serial Port Interface To         //
//                   16x2 LCD                            //
// Crystal         : 24.000000 MHz                       //
// Microcontroller : AT89C51-C52-C55-S51-S52             //
///////////////////////////////////////////////////////////

// Header file for AT89x51 regiter definitions.
#include <AT89x51.H>
#include <string.h>

// Header file for serial communication functions.
#include "Serial.h"

// Header file for 16x2 LCD functions.
#include "lcd4bit.h"

void InitSystem()
{
	InitSerial();
	init_lcd();
	// Display title information on LCD.
	print_lcd("  Micro Digital  \0");
	gotoxy_lcd(1, 2);
	print_lcd("micro-digital.net\0");

	// Print title information on PC.
	uputs("PC Serial Port Interface To 16x2 LCD\r\r\0");
	uputs("By    : Micro Digital\r\0");
	uputs("Web   : http://www.micro-digital.net\r\0");
	uputs("Email : udigital.solutions@gmail.com\r\0");
	uputs("Cell  : +92-332-555-8051\r\r\0");
	/////////////////////////////////////////////////////////

}

void main()
{
	char Line[21];
	char LineNumber;
	
	// Initialize System.
	InitSystem();
	
	// Loop until power is applied to microcontroller.
	while(1)
	{
		// Read line from PC.
		ugets(Line, 20);

		// Received line length should be greater than 4.
		if(strlen(Line) > 4)
		{
			// Is write operation selected.
			if(Line[0] == 'w')
			{
				// Extract Line number information.
				LineNumber = Line[2] - '0';
				
				// If line 1 of text LCD selected
				// then locate line 1 and display
				// given text.
				if(LineNumber == 1)
				{
					gotoxy_lcd(1, 1);
					print_lcd(&Line[4]);
				}

				// If line 2 of text LCD selected
				// then locate line 2 and display
				// given text.
				if(LineNumber == 2)
				{
					gotoxy_lcd(1, 2);
					print_lcd(&Line[4]);
				}
			}
		}
	}
}

