
#include <AT89x51.H>
#include "Serial.h"

//Initializes serial interface at 9600 b/s @ 24 MHz (Double boud rate mode).
void InitSerial()
{
	// Mode 1: 8-bit UART, enable receiver,
	// set transmited flag to 1.
	SCON  = 0x52;
	
	// Timer 1 mode 2: 8-Bit reload.
	TMOD |= 0x20;
	
	// Reload value 4800 baud.
	TH1   = 0xf3;

	// Enable double baud rate mode resulting 
	// 9600 bps(4800 bps * 2 = 9600 bps)
	PCON |= 0X80;

	// Enable all interupts.
	EA = 1;
	// Run timer 1.
	TR1 = 1;
}

void uputc(unsigned char Byte)
{
	while(!TI);
	SBUF = Byte;
	TI = 0;
}

void uputs(unsigned char String[])//, char bCarriageReturn)
{
	unsigned int i = 0;
	while(*String != '\0')
	{
		uputc(*String);
		String ++;
	}
}

#define getc getch

char ugetc()
{
	while(!RI);
	RI = 0;
	return SBUF;
}

unsigned int ugets(char String[], unsigned short MaxLen)
{
	char c;
	unsigned short Len = 0;
	unsigned short Pos = 0;
	do
	{
		c = ugetc();
		if(Pos < MaxLen && c != '\r')
			String[Pos ++] = c;
		Len ++;
	}
	while(c != '\r');

	String[Pos] = '\0';
	return Len;
}

